1 #
   2 # Copyright (c) 2006, 2013, Oracle and/or its affiliates. All rights reserved.
   3 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
   4 #
   5 # This code is free software; you can redistribute it and/or modify it
   6 # under the terms of the GNU General Public License version 2 only, as
   7 # published by the Free Software Foundation.
   8 #
   9 # This code is distributed in the hope that it will be useful, but WITHOUT
  10 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  11 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  12 # version 2 for more details (a copy is included in the LICENSE file that
  13 # accompanied this code).
  14 #
  15 # You should have received a copy of the GNU General Public License version
  16 # 2 along with this work; if not, write to the Free Software Foundation,
  17 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  18 #
  19 # Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  20 # or visit www.oracle.com if you need additional information or have any
  21 # questions.
  22 #
  23 
  24 # @test
  25 # @summary (almost) all keytool behaviors
  26 # @author Weijun Wang
  27 #
  28 # This test is only executed on several platforms
  29 #
  30 # set a few environment variables so that the shell-script can run stand-alone
  31 # in the source directory
  32 if [ "${TESTSRC}" = "" ] ; then
  33   TESTSRC="."
  34 fi
  35 if [ "${TESTCLASSES}" = "" ] ; then
  36   TESTCLASSES="."
  37 fi
  38 if [ "${TESTJAVA}" = "" ] ; then
  39   echo "TESTJAVA not set.  Test cannot execute."
  40   echo "FAILED!!!"
  41   exit 1
  42 fi
  43 if [ "${COMPILEJAVA}" = "" ]; then
  44   COMPILEJAVA="${TESTJAVA}"
  45 fi
  46 
  47 find_one() {
  48   for TARGET_FILE in $@; do
  49     if [ -e "$TARGET_FILE" ]; then
  50       echo $TARGET_FILE
  51       return
  52     fi
  53   done
  54 }
  55 
  56 FS="/"
  57 ${TESTJAVA}${FS}bin${FS}java ${TESTVMOPTS} ${TESTJAVAOPTS} -XshowSettings:properties -version 2> allprop
  58 cat allprop | grep sun.arch.data.model | grep 32
  59 if [ "$?" != "0" ]; then
  60   B32=false
  61 else
  62   B32=true
  63 fi
  64 
  65 # set platform-dependent variables
  66 OS=`uname -s`
  67 case "$OS" in
  68   SunOS )
  69     FS="/"
  70     LIBNAME="/usr/lib/mps/`isainfo -n`/libsoftokn3.so"
  71     ;;
  72   Linux )
  73     if [ $B32 = true ]; then
  74         LIBNAME=`find_one \
  75             "/usr/lib/libsoftokn3.so" \
  76             "/usr/lib/i386-linux-gnu/nss/libsoftokn3.so" \
  77             "/usr/lib/nss/libsoftokn3.so"`
  78     else
  79         LIBNAME=`find_one \
  80             "/usr/lib64/libsoftokn3.so" \
  81             "/usr/lib/x86_64-linux-gnu/nss/libsoftokn3.so" \
  82             "/usr/lib/nss/libsoftokn3.so"`
  83     fi
  84     ;;
  85   * )
  86     echo "Will not run test on: ${OS}"
  87     exit 0;
  88     ;;
  89 esac
  90 
  91 if [ "$LIBNAME" = "" ]; then
  92   echo "Cannot find libsoftokn3.so"
  93   exit 0
  94 fi
  95 
  96 ${COMPILEJAVA}${FS}bin${FS}javac ${TESTJAVACOPTS} ${TESTTOOLVMOPTS} -d . -XDignore.symbol.file \
  97         ${TESTSRC}${FS}KeyToolTest.java || exit 10
  98 
  99 NSS=${TESTSRC}${FS}..${FS}..${FS}pkcs11${FS}nss
 100 
 101 cp ${TESTSRC}${FS}p11-nss.txt .
 102 cp ${NSS}${FS}db${FS}cert8.db .
 103 cp ${NSS}${FS}db${FS}key3.db .
 104 cp ${NSS}${FS}db${FS}secmod.db .
 105 
 106 chmod u+w key3.db
 107 chmod u+w cert8.db
 108 
 109 echo | ${TESTJAVA}${FS}bin${FS}java ${TESTVMOPTS} ${TESTJAVAOPTS} -Dnss \
 110    -Dnss.lib=${LIBNAME} \
 111    KeyToolTest
 112 status=$?
 113 
 114 rm -f p11-nss.txt
 115 rm -f cert8.db
 116 rm -f key3.db
 117 rm -f secmod.db
 118 
 119 rm HumanInputStream*.class
 120 rm KeyToolTest*.class
 121 rm TestException.class
 122 
 123 exit $status